/**
 * Revolution Multimedia Gallery PACKAGED v2.0
 * General settings js file.
 *
 * @author Tibi - FWDesign [https://webdesign-flash.ro/]
 * Copyright © All Rights Reserved.
 */

jQuery(document).ready(function($){
	var DEFAULT_SKINS_NR = 1;
	
	var cur_settings_obj;
	var fValid = false;
	
	// Init UI.
	$("#tabs").tabs();
	$("#menuBackgroundColor, #slideShowBkColor, #slideShowFillColor, #itemBackgroundColor, #itemBorderColor, #preloaderBkColor, #preloaderFillColor, #backgroundColor, #shareMainBackgroundColor, #shareBackgroundColor, #thumbnailsOverlayColor, #thumbnailsBorderColor, #timeColor, #youtubeQualityButtonNormalColor, #youtubeQualityButtonSelectedColor, #scrubbersToolTipLabelBackgroundColor, #scrubbersToolTipLabelFontColor, #audioVisualizerLinesColor, #audioVisualizerCircleColor, #thumbnailsPreviewBackgroundColor, #thumbnailsPreviewLabelBackgroundColor, #thumbnailsPreviewLabelFontColor").spectrum({
  	    color: "#5a5a5a",
  	  	chooseText: "Update",
  	  	showInitial: true,
  	  	showInput: true,
  	  	allowEmpty:true,
  	  	preferredFormat: "hex6"
  	});

	// Init tooltips.
	$("#tabs img").fwdTooltip({});

    // Init.
    function init(){   
    	$.each(settingsAr, function(i, el){
			$("#skins").append("<option value='" + el.id + "'>" + el.name + "</option>");
		});
    	
		
    	$("#skins").val(sid);
    	
    	if (cur_order_id < DEFAULT_SKINS_NR){
    		$("#update_btn").hide();
            $("#del_btn").hide();
    	}else{
    		$("#update_btn").show();
            $("#del_btn").show();
    	}
	    
	    setSettings();
	    
	    $("#preset_id").html("ID : " + sid);
	    $("#tabs").tabs("option", "active", tab_init_id);
    }

	init();

	$("#skins").change(function(){
    	sid = parseInt($("#skins").val());
    	
    	$.each(settingsAr, function(i, el){
			if (sid == el.id){
				cur_order_id = i;
			}
		});
    	
    	setSettings();
    	
    	if (cur_order_id < DEFAULT_SKINS_NR){
    		$("#update_btn").hide();
            $("#del_btn").hide();
    	}else{
    		$("#update_btn").show();
            $("#del_btn").show();
    	}
    	
    	allFields.removeClass("ui-state-error");
    	$("#tips").text("All form fields are required.");
    	
    	$("#preset_id").html("ID : " + sid);
    });
	
	//#############################################//
	/* Set settings */
	//#############################################//
    function setSettings() {
    	var settings_obj = settingsAr[cur_order_id];
		
		// Main settings.
		$("#name").val(settings_obj.name);
		$("#rightClickContextMenu").val(String(settings_obj.rightClickContextMenu));
		$("#useDeepLinking").val(String(settings_obj.useDeepLinking));
		$("#useVectorIcons").val(String(settings_obj.useVectorIcons));
		$("#showMenuButton").val(String(settings_obj.showMenuButton));
		$("#showAllGalleries").val(String(settings_obj.showAllGalleries));
		$("#allGalleriesLabel").val(String(settings_obj.allGalleriesLabel));
		$("#maxWidth").val(String(settings_obj.maxWidth));
		$("#maxHeight").val(String(settings_obj.maxHeight));
		$("#minHeight").val(String(settings_obj.minHeight));
		$("#startAtGallery").val(String(settings_obj.startAtGallery));
		$("#startAtItem").val(String(settings_obj.startAtItem));
		$("#displayType").val(String(settings_obj.displayType));
		$("#autoScale").val(String(settings_obj.autoScale));
		$("#zIndex").val(String(settings_obj.zIndex));	
		$("#randomizeGalleries").val(String(settings_obj.randomizeGalleries));
		$("#buttonsAlignment").val(String(settings_obj.buttonsAlignment));
		$("#mediaLazyLoading").val(String(settings_obj.mediaLazyLoading));
		$("#useDrag").val(String(settings_obj.useDrag));
		$("#showSlideShowButton").val(String(settings_obj.showSlideShowButton));
		$("#showSlideShowAnimation").val(String(settings_obj.showSlideShowAnimation));
		$("#slideShowAutoPlay").val(String(settings_obj.slideShowAutoPlay));
		$("#slideShowAutoStop").val(String(settings_obj.slideShowAutoStop));
		$("#slideShowDelay").val(String(settings_obj.slideShowDelay));
		$("#slideShowBkColor").val(String(settings_obj.slideShowBkColor));
		$("#slideShowFillColor").val(String(settings_obj.slideShowFillColor));
		$("#useKeyboard").val(String(settings_obj.useKeyboard));
		$("#useDoubleClick").val(String(settings_obj.useDoubleClick));
		$("#showFullscreenButton").val(String(settings_obj.showFullscreenButton));
		$("#showZoomButton").val(String(settings_obj.showZoomButton));
		$("#showCounter").val(String(settings_obj.showCounter));
		$("#showNextAndPrevBtns").val(String(settings_obj.showNextAndPrevBtns));
		$("#hideButtonsOnDrag").val(String(settings_obj.hideButtonsOnDrag));
		$("#maxZoom").val(String(settings_obj.maxZoom));
		$("#buttonsHideDelay").val(String(settings_obj.buttonsHideDelay));
		$("#defaultItemWidth").val(String(settings_obj.defaultItemWidth));
		$("#defaultItemHeight").val(String(settings_obj.defaultItemHeight));
		$("#itemOffsetHeight").val(String(settings_obj.itemOffsetHeight));
		$("#itemOffsetHeightButtonsTop").val(String(settings_obj.itemOffsetHeightButtonsTop));
		$("#spaceBetweenBtns").val(String(settings_obj.spaceBetweenBtns));
		$("#buttonsOffsetIn").val(String(settings_obj.buttonsOffsetIn));
		$("#buttonsOffsetOut").val(String(settings_obj.buttonsOffsetOut));
		$("#itemBorderSize").val(String(settings_obj.itemBorderSize));
		$("#slideShowBkColor").spectrum("set", settings_obj.slideShowBkColor != "transparent" ? settings_obj.slideShowBkColor : null);
		$("#slideShowFillColor").spectrum("set", settings_obj.slideShowFillColor != "transparent" ? settings_obj.slideShowFillColor : null);
		$("#itemBackgroundColor").spectrum("set", settings_obj.itemBackgroundColor != "transparent" ? settings_obj.itemBackgroundColor : null);
		$("#itemBorderColor").spectrum("set", settings_obj.itemBorderColor != "transparent" ? settings_obj.itemBorderColor : null);
		$("#preloaderBkColor").spectrum("set", settings_obj.preloaderBkColor != "transparent" ? settings_obj.preloaderBkColor : null);
		$("#preloaderFillColor").spectrum("set", settings_obj.preloaderFillColor != "transparent" ? settings_obj.preloaderFillColor : null);
		$("#backgroundColor").spectrum("set", settings_obj.backgroundColor != "transparent" ? settings_obj.backgroundColor : null);

		// Share window. 
		$("#shareButtons").val(String(settings_obj.shareButtons));
		$("#shareText").val(String(settings_obj.shareText));
		$("#sharedURL").val(String(settings_obj.sharedURL));
		$("#shareMainBackgroundColor").spectrum("set", settings_obj.shareMainBackgroundColor != "transparent" ? settings_obj.shareMainBackgroundColor : null);
		$("#shareBackgroundColor").spectrum("set", settings_obj.shareBackgroundColor != "transparent" ? settings_obj.shareBackgroundColor : null);
		
		// Thumbnail settings.
		$("#showThumbnails").val(String(settings_obj.showThumbnails));
		$("#showThumbnailsIcon").val(String(settings_obj.showThumbnailsIcon));
		$("#thumbnailsHeight").val(String(settings_obj.thumbnailsHeight));
		$("#thumbnailsBorderSize").val(String(settings_obj.thumbnailsBorderSize));
		$("#spaceBetweenThumbnailsAndItem").val(String(settings_obj.spaceBetweenThumbnailsAndItem));
		$("#spaceBetweenThumbnails").val(String(settings_obj.spaceBetweenThumbnails));
		$("#thumbnailsOverlayColor").spectrum("set", settings_obj.thumbnailsOverlayColor != "transparent" ? settings_obj.thumbnailsOverlayColor : null);
		$("#thumbnailsBorderColor").spectrum("set", settings_obj.thumbnailsBorderColor != "transparent" ? settings_obj.thumbnailsBorderColor : null);
		
		// Caption settings.
		$("#caption").val(String(settings_obj.caption));
		$("#captionPosition").val(String(settings_obj.captionPosition));
		$("#showCaptionOnSmallScreens").val(String(settings_obj.showCaptionOnSmallScreens));
		$("#animateCaption").val(String(settings_obj.animateCaption));
		$("#captionAnimationType").val(String(settings_obj.captionAnimationType));
		
		//Video and audio settings
		$("#useVideo").val(String(settings_obj.useVideo));
		$("#fillEntireScreenWithPoster").val(String(settings_obj.fillEntireScreenWithPoster));
		$("#volume").val(String(settings_obj.volume));
		$("#videoAutoPlay").val(String(settings_obj.videoAutoPlay));
		$("#nextVideoAutoPlay").val(String(settings_obj.nextVideoAutoPlay));
		$("#videoAutoPlayText").val(String(settings_obj.videoAutoPlayText));
		$("#showLogo").val(String(settings_obj.showLogo));
		$("#logoPath").val(String(settings_obj.logoPath));
		$("#logoLink").val(String(settings_obj.logoLink));
		$("#showControllerWhenVideoIsStopped").val(String(settings_obj.showControllerWhenVideoIsStopped));
		$("#showDefaultControllerForVimeo").val(String(settings_obj.showDefaultControllerForVimeo));
		$("#showScrubberWhenControllerIsHidden").val(String(settings_obj.showScrubberWhenControllerIsHidden));
		$("#showRewindButton").val(String(settings_obj.showRewindButton));
		$("#showVolumeButton").val(String(settings_obj.showVolumeButton));
		$("#showTime").val(String(settings_obj.showTime));
		$("#showChromecastButton").val(String(settings_obj.showChromecastButton));
		$("#showPlaybackRateButton").val(String(settings_obj.showPlaybackRateButton));
		$("#showQualityButton").val(String(settings_obj.showQualityButton));
		$("#showFullScreenButton").val(String(settings_obj.showFullScreenButton));
		$("#showScrubberToolTipLabel").val(String(settings_obj.showScrubberToolTipLabel));
		$("#thumbnailsPreviewWidth").val(String(settings_obj.thumbnailsPreviewWidth));
		$("#skipToVideoText").val(String(settings_obj.skipToVideoText));
		$("#skipToVideoButtonText").val(String(settings_obj.skipToVideoButtonText));
		$("#timeColor").spectrum("set", settings_obj.timeColor != "transparent" ? settings_obj.timeColor : null);
		$("#youtubeQualityButtonNormalColor").spectrum("set", settings_obj.youtubeQualityButtonNormalColor != "transparent" ? settings_obj.youtubeQualityButtonNormalColor : null);
		$("#youtubeQualityButtonSelectedColor").spectrum("set", settings_obj.youtubeQualityButtonSelectedColor != "transparent" ? settings_obj.youtubeQualityButtonSelectedColor : null);
		$("#scrubbersToolTipLabelBackgroundColor").spectrum("set", settings_obj.scrubbersToolTipLabelBackgroundColor != "transparent" ? settings_obj.scrubbersToolTipLabelBackgroundColor : null);
		$("#scrubbersToolTipLabelFontColor").spectrum("set", settings_obj.scrubbersToolTipLabelFontColor != "transparent" ? settings_obj.scrubbersToolTipLabelFontColor : null);
		$("#audioVisualizerLinesColor").spectrum("set", settings_obj.audioVisualizerLinesColor != "transparent" ? settings_obj.audioVisualizerLinesColor : null);
		$("#audioVisualizerCircleColor").spectrum("set", settings_obj.audioVisualizerCircleColor != "transparent" ? settings_obj.audioVisualizerCircleColor : null);
		$("#thumbnailsPreviewBackgroundColor").spectrum("set", settings_obj.thumbnailsPreviewBackgroundColor != "transparent" ? settings_obj.thumbnailsPreviewBackgroundColor : null);
		$("#thumbnailsPreviewLabelBackgroundColor").spectrum("set", settings_obj.thumbnailsPreviewLabelBackgroundColor != "transparent" ? settings_obj.thumbnailsPreviewLabelBackgroundColor : null);
		$("#thumbnailsPreviewLabelFontColor").spectrum("set", settings_obj.thumbnailsPreviewLabelFontColor != "transparent" ? settings_obj.thumbnailsPreviewLabelFontColor : null);
		$("#menuBackgroundColor").spectrum("set", settings_obj.menuBackgroundColor != "transparent" ? settings_obj.menuBackgroundColor : null);
    }
        
	
	// Update settings.
    function updateSettings(){

		// Main settings.
		cur_settings_obj.id = sid;
    	cur_settings_obj.name = $("#name").val().replace(/"/g, "'");
		cur_settings_obj.rightClickContextMenu = $("#rightClickContextMenu").val();
		cur_settings_obj.useDeepLinking = $("#useDeepLinking").val();
		cur_settings_obj.useVectorIcons = $("#useVectorIcons").val();	
		cur_settings_obj.showMenuButton = $("#showMenuButton").val();
		cur_settings_obj.showAllGalleries = $("#showAllGalleries").val();	
		cur_settings_obj.allGalleriesLabel = $("#allGalleriesLabel").val().replace(/"/g, "'");
		cur_settings_obj.maxWidth = $("#maxWidth").val().replace(/"/g, "'");
		cur_settings_obj.maxHeight = $("#maxHeight").val().replace(/"/g, "'");
		cur_settings_obj.minHeight = $("#minHeight").val().replace(/"/g, "'");
		cur_settings_obj.startAtGallery = $("#startAtGallery").val().replace(/"/g, "'");
		cur_settings_obj.startAtItem = $("#startAtItem").val().replace(/"/g, "'");
		cur_settings_obj.displayType = $("#displayType").val();
		cur_settings_obj.autoScale = $("#autoScale").val();
		cur_settings_obj.zIndex = $("#zIndex").val();	
		cur_settings_obj.randomizeGalleries = $("#randomizeGalleries").val();
		cur_settings_obj.buttonsAlignment = $("#buttonsAlignment").val();
		cur_settings_obj.mediaLazyLoading = $("#mediaLazyLoading").val();
		cur_settings_obj.useDrag = $("#useDrag").val();
		cur_settings_obj.showSlideShowButton = $("#showSlideShowButton").val();
		cur_settings_obj.showSlideShowAnimation = $("#showSlideShowAnimation").val();
		cur_settings_obj.slideShowAutoPlay = $("#slideShowAutoPlay").val();
		cur_settings_obj.slideShowAutoStop = $("#slideShowAutoStop").val();
		cur_settings_obj.slideShowDelay = $("#slideShowDelay").val().replace(/"/g, "'");
		cur_settings_obj.slideShowBkColor = $("#slideShowBkColor").spectrum("get") ? $("#slideShowBkColor").spectrum("get").toHexString() : "transparent";	
		cur_settings_obj.slideShowFillColor = $("#slideShowFillColor").spectrum("get") ? $("#slideShowFillColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.useKeyboard = $("#useKeyboard").val();
		cur_settings_obj.useDoubleClick = $("#useDoubleClick").val();
		cur_settings_obj.showFullscreenButton = $("#showFullscreenButton").val();
		cur_settings_obj.showZoomButton = $("#showZoomButton").val();		
		cur_settings_obj.showCounter = $("#showCounter").val();
		cur_settings_obj.showNextAndPrevBtns = $("#showNextAndPrevBtns").val();
		cur_settings_obj.hideButtonsOnDrag = $("#hideButtonsOnDrag").val();		
		cur_settings_obj.maxZoom = $("#maxZoom").val().replace(/"/g, "'");
		cur_settings_obj.buttonsHideDelay = $("#buttonsHideDelay").val().replace(/"/g, "'");
		cur_settings_obj.defaultItemWidth = $("#defaultItemWidth").val().replace(/"/g, "'");
		cur_settings_obj.defaultItemHeight = $("#defaultItemHeight").val().replace(/"/g, "'");
		cur_settings_obj.itemOffsetHeight = $("#itemOffsetHeight").val().replace(/"/g, "'");
		cur_settings_obj.itemOffsetHeightButtonsTop = $("#itemOffsetHeightButtonsTop").val().replace(/"/g, "'");
		cur_settings_obj.spaceBetweenBtns = $("#spaceBetweenBtns").val().replace(/"/g, "'");
		cur_settings_obj.buttonsOffsetIn = $("#buttonsOffsetIn").val().replace(/"/g, "'");
		cur_settings_obj.buttonsOffsetOut = $("#buttonsOffsetOut").val().replace(/"/g, "'");
		cur_settings_obj.itemBorderSize = $("#itemBorderSize").val().replace(/"/g, "'");
		cur_settings_obj.itemBackgroundColor = $("#itemBackgroundColor").spectrum("get") ? $("#itemBackgroundColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.itemBorderColor = $("#itemBorderColor").spectrum("get") ? $("#itemBorderColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.preloaderBkColor = $("#preloaderBkColor").spectrum("get") ? $("#preloaderBkColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.preloaderFillColor = $("#preloaderFillColor").spectrum("get") ? $("#preloaderFillColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.backgroundColor = $("#backgroundColor").spectrum("get") ? $("#backgroundColor").spectrum("get").toRgbString() : "transparent";

		// Share window settings.
		cur_settings_obj.shareButtons = $("#shareButtons").val().replace(/"/g, "'");
		cur_settings_obj.shareText = $("#shareText").val().replace(/"/g, "'");
		cur_settings_obj.sharedURL = $("#sharedURL").val().replace(/"/g, "'");
		cur_settings_obj.shareMainBackgroundColor = $("#shareMainBackgroundColor").spectrum("get") ? $("#shareMainBackgroundColor").spectrum("get").toRgbString() : "transparent";
		cur_settings_obj.shareBackgroundColor = $("#shareBackgroundColor").spectrum("get") ? $("#shareBackgroundColor").spectrum("get").toHexString() : "transparent";

		// Thumbnails settings.
		cur_settings_obj.showThumbnails = $("#showThumbnails").val();
		cur_settings_obj.showThumbnailsIcon = $("#showThumbnailsIcon").val();
		cur_settings_obj.thumbnailsHeight = $("#thumbnailsHeight").val().replace(/"/g, "'");
		cur_settings_obj.thumbnailsBorderSize = $("#thumbnailsBorderSize").val().replace(/"/g, "'");
		cur_settings_obj.spaceBetweenThumbnailsAndItem = $("#spaceBetweenThumbnailsAndItem").val().replace(/"/g, "'");
		cur_settings_obj.spaceBetweenThumbnails = $("#spaceBetweenThumbnails").val().replace(/"/g, "'");
		cur_settings_obj.thumbnailsOverlayColor = $("#thumbnailsOverlayColor").spectrum("get") ? $("#thumbnailsOverlayColor").spectrum("get").toRgbString() : "transparent";
		cur_settings_obj.thumbnailsBorderColor = $("#thumbnailsBorderColor").spectrum("get") ? $("#thumbnailsBorderColor").spectrum("get").toHexString() : "transparent";

		// Caption settings.
		cur_settings_obj.caption = $("#caption").val();
		cur_settings_obj.captionPosition = $("#captionPosition").val();
		cur_settings_obj.showCaptionOnSmallScreens = $("#showCaptionOnSmallScreens").val();
		cur_settings_obj.animateCaption = $("#animateCaption").val();
		cur_settings_obj.captionAnimationType = $("#captionAnimationType").val();

		// Video & audio player.
		cur_settings_obj.useVideo = $("#useVideo").val();
		cur_settings_obj.fillEntireScreenWithPoster = $("#fillEntireScreenWithPoster").val();
		cur_settings_obj.volume = $("#volume").val().replace(/"/g, "'");
		cur_settings_obj.videoAutoPlay = $("#videoAutoPlay").val();
		cur_settings_obj.nextVideoAutoPlay = $("#nextVideoAutoPlay").val();
		cur_settings_obj.videoAutoPlayText = $("#videoAutoPlayText").val().replace(/"/g, "'");
		cur_settings_obj.showLogo = $("#showLogo").val();
		cur_settings_obj.logoPath = $("#logoPath").val().replace(/"/g, "'");
		cur_settings_obj.logoLink = $("#logoLink").val().replace(/"/g, "'");
		cur_settings_obj.showControllerWhenVideoIsStopped = $("#showControllerWhenVideoIsStopped").val();
		cur_settings_obj.showDefaultControllerForVimeo = $("#showDefaultControllerForVimeo").val();
		cur_settings_obj.showScrubberWhenControllerIsHidden = $("#showScrubberWhenControllerIsHidden").val();	
		cur_settings_obj.showRewindButton = $("#showRewindButton").val();
		cur_settings_obj.showVolumeButton = $("#showVolumeButton").val();
		cur_settings_obj.showTime = $("#showTime").val();
		cur_settings_obj.showChromecastButton = $("#showChromecastButton").val();
		cur_settings_obj.showPlaybackRateButton = $("#showPlaybackRateButton").val();
		cur_settings_obj.showQualityButton = $("#showQualityButton").val();
		cur_settings_obj.showFullScreenButton = $("#showFullScreenButton").val();
		cur_settings_obj.showScrubberToolTipLabel = $("#showScrubberToolTipLabel").val();
		cur_settings_obj.thumbnailsPreviewWidth = $("#thumbnailsPreviewWidth").val().replace(/"/g, "'");
		cur_settings_obj.skipToVideoText = $("#skipToVideoText").val().replace(/"/g, "'");
		cur_settings_obj.skipToVideoButtonText = $("#skipToVideoButtonText").val().replace(/"/g, "'");
		cur_settings_obj.timeColor = $("#timeColor").spectrum("get") ? $("#timeColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.youtubeQualityButtonNormalColor = $("#youtubeQualityButtonNormalColor").spectrum("get") ? $("#youtubeQualityButtonNormalColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.youtubeQualityButtonSelectedColor = $("#youtubeQualityButtonSelectedColor").spectrum("get") ? $("#youtubeQualityButtonSelectedColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.scrubbersToolTipLabelBackgroundColor = $("#scrubbersToolTipLabelBackgroundColor").spectrum("get") ? $("#scrubbersToolTipLabelBackgroundColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.scrubbersToolTipLabelFontColor = $("#scrubbersToolTipLabelFontColor").spectrum("get") ? $("#scrubbersToolTipLabelFontColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.audioVisualizerLinesColor = $("#audioVisualizerLinesColor").spectrum("get") ? $("#audioVisualizerLinesColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.audioVisualizerCircleColor = $("#audioVisualizerCircleColor").spectrum("get") ? $("#audioVisualizerCircleColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.thumbnailsPreviewBackgroundColor = $("#thumbnailsPreviewBackgroundColor").spectrum("get") ? $("#thumbnailsPreviewBackgroundColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.thumbnailsPreviewLabelBackgroundColor = $("#thumbnailsPreviewLabelBackgroundColor").spectrum("get") ? $("#thumbnailsPreviewLabelBackgroundColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.thumbnailsPreviewLabelFontColor = $("#thumbnailsPreviewLabelFontColor").spectrum("get") ? $("#thumbnailsPreviewLabelFontColor").spectrum("get").toHexString() : "transparent";
		cur_settings_obj.menuBackgroundColor = $("#menuBackgroundColor").spectrum("get") ? $("#menuBackgroundColor").spectrum("get").toHexString() : "transparent";
    }
    
	//#####################################################//
	/* validation functions */
	//#####################################################// 
	var allFields = $([]).add($("#maxWidth")).add($("#maxHeight")).add($("#startAtGallery")).add($("#startAtItem")).add($("#minHeight")).add($("#slideShowDelay")).add($("#maxZoom")).add($("#buttonsHideDelay")).add($("#defaultItemWidth")).add($("#defaultItemHeight")).add($("#itemOffsetHeight")).add($("#itemOffsetHeightButtonsTop")).add($("#spaceBetweenBtns")).add($("#buttonsOffsetIn")).add($("#buttonsOffsetOut")).add($("#itemBorderSize")).add($("#allGalleriesLabel")).add($("#shareText")).add($("#thumbnailsHeight")).add($("#thumbnailsBorderSize")).add($("#spaceBetweenThumbnailsAndItem")).add($("#spaceBetweenThumbnails")).add($("#volume")).add($("#videoAutoPlayText")).add($("#thumbnailsPreviewWidth"));
	
	function validateFields(){
		fValid = true;
      	allFields.removeClass("ui-state-error");

      	// Main settings.
      	fValid = fValid && checkIfIntegerAndLength($("#zIndex"), "z-index", 1, 10);
      	fValid = fValid && checkIfIntegerAndLength($("#maxWidth"), "gallery maximum width", 1, 5);
      	fValid = fValid && checkIfIntegerAndLength($("#maxHeight"), "gallery maximum height", 1, 5);
      	fValid = fValid && checkIfIntegerAndLength($("#minHeight"), "gallery maximum height", 1, 4);
      	fValid = fValid && checkIfIntegerAndLength($("#startAtGallery"), "start at gallery", 1, 5);
      	fValid = fValid && checkIfIntegerAndLength($("#startAtItem"), "start at item", 1, 5);
      	fValid = fValid && checkIfFloatAndLength2($("#slideShowDelay"), "slideshow delay", 1, 3);
      	fValid = fValid && checkIfFloatAndLength2($("#maxZoom"), "maximum zoom", 1, 3);
      	fValid = fValid && checkIfFloatAndLength2($("#buttonsHideDelay"), "buttons hide delay", 1, 5);
      	fValid = fValid && checkIfIntegerAndLength($("#defaultItemWidth"), "default item width", 1, 4);
      	fValid = fValid && checkIfIntegerAndLength($("#defaultItemHeight"), "default item height", 1, 4);
      	fValid = fValid && checkIfIntegerAndLength($("#itemOffsetHeight"), "item offset height", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#itemOffsetHeightButtonsTop"), "offset for buttons when aligned top", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#spaceBetweenBtns"), "space between buttons", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#buttonsOffsetIn"), "buttons offset in", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#buttonsOffsetOut"), "buttons offset out", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#itemBorderSize"), "item border size", 1, 3);		

      	if (!fValid){
      		$("#tabs").tabs("option", "active", 0);
      		window.scrollTo(0,0);	
      		return false;
      	}

      	// Menu window.
      	fValid = fValid && checkLength($("#allGalleriesLabel"), "all galleries label", 1, 100);
      	if (!fValid){
      		$("#tabs").tabs("option", "active", 1);
      		window.scrollTo(0,0);	
      		return false;
      	}

		
		// Share window.
      	fValid = fValid && checkLength($("#shareText"), "share window text", 1, 80);

      	if (!fValid){
      		$("#tabs").tabs("option", "active", 2);
      		window.scrollTo(0,0);	
      		return false;
      	}

      	// Thumbnails settings.
      	fValid = fValid && checkIfIntegerAndLength($("#thumbnailsHeight"), "thumbnails height", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#thumbnailsBorderSize"), "thumbnails border size", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#spaceBetweenThumbnailsAndItem"), "space between thumbnails and item", 1, 3);
      	fValid = fValid && checkIfIntegerAndLength($("#spaceBetweenThumbnails"), "space between thumbnails", 1, 3);
      
      	if (!fValid){
      		$("#tabs").tabs("option", "active", 3);
      		window.scrollTo(0,0);	
      		return false;
      	}

      	// Video & audio player.
      	fValid = fValid && checkIfFloatAndLength2($("#volume"), "volume", 1, 3);
      	fValid = fValid && checkLength($("#videoAutoPlayText"), "video autoplay text", 1, 100);
      	fValid = fValid && checkIfIntegerAndLength($("#thumbnailsPreviewWidth"), "thumbnails preview window width", 1, 3);
      	
      	if (!fValid){
      		$("#tabs").tabs("option", "active", 5);
      		window.scrollTo(0,0);	
      		return false;
      	}
	}

	$("#add_btn").click(function(e){
		
		if($("#name").val() == settingsAr[cur_order_id]["name"]){
			updateTips("Please make sure that the preset name is unique");
			$("#name").addClass("ui-state-error");
			$("#tabs").tabs("option", "active", 0);
			window.scrollTo(0,0);
			return false;
		};
		
    	validateFields();

      	if (fValid){
      		cur_settings_obj = {};
        	
        	sid = $("#skins option").length;
        	cur_order_id = $("#skins option").length;
        	
      		var idsAr = [];
      		
      		if (sid > DEFAULT_SKINS_NR){
      			$.each(settingsAr, function(i, el){
    				idsAr.push(el.id);
    			});
          		
          		for (var i=DEFAULT_SKINS_NR; i<settingsAr.length; i++){
          			if ($.inArray(i, idsAr) == -1){
          				sid = i;
          				break;
          			}
          		}
      		}
        	
			
	    	updateSettings();
	    	settingsAr.push(cur_settings_obj);
	    	
	    	var data_obj ={
	    		action: "add",
	    		set_id: sid,
	    		set_order_id: cur_order_id,
	    		tab_init_id: $("#tabs").tabs("option", "active"),
	    		settings_ar: settingsAr
	    	};
	    	
	    	$("#settings_data").val(JSON.stringify(data_obj));
			
        }else{
      		return false;
      	}
    });

    
    $("#update_btn").click(function(){
    	validateFields();

      	if (fValid){
      		cur_settings_obj = {};
      		
	    	updateSettings();
	    	
	    	settingsAr[cur_order_id] = cur_settings_obj;
	    	
	    	var data_obj ={
	    		action: "save",
	    		set_id: sid,
	    		set_order_id: cur_order_id,
	    		tab_init_id: $("#tabs").tabs("option", "active"),
	    		settings_ar: settingsAr
	    	};
	    	
	    	$("#settings_data").val(JSON.stringify(data_obj));
        }else{
      		return false;
      	}
    });
    
    $("#del_btn").click(function(){
    	settingsAr.splice(cur_order_id, 1);
    	
    	var data_obj ={
    		action: "del",
    		settings_ar: settingsAr
    	};
    	
    	$("#settings_data").val(JSON.stringify(data_obj));
    });
   


    //logo image
  	var logoUploader;
    
    $("#uvp_logo_image_btn").click(function(e){
        e.preventDefault();
 
        //If the uploader object has already been created, reopen the dialog
        if (logoUploader){
          logoUploader.open();
            return;
        }
        
        //Extend the wp.media object
        logoUploader = wp.media.frames.file_frame = wp.media({
            title: "Choose Image",
            button:
            {
                text: "Add Image"
            },
            library:
            {
              type: "image"
            },
            multiple: false
        });
 
        //When a file is selected, grab the URL and set it as the text field's value
        logoUploader.on("select", function(){
            attachment = logoUploader.state().get("selection").first().toJSON();
            
            $("#logoPath").val(attachment.url);
        });
 
        //Open the uploader dialog
        logoUploader.open();
    });
	
	//#########################################//
	/* Validation functions */
	//#########################################//
	function checkLength(el, prop, min, max){
      	if ((el.val().length > max) || (el.val().length < min)){
        	el.addClass("ui-state-error");
        	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
        	
        	return false;
      	}else{
        	return true;
      	}
	}
    
    function checkIfIntegerAndLength(el, prop, min, max){
    	var int_reg_exp = /-?[0-9]+/;
    	var str = el.val();
    	var res = str.match(int_reg_exp);
    	
    	if (res && (res[0] == str)){
    		if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");	
            	return false;
          	}else{
            	return true;
          	}
        }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be an integer.");
        	return false;
        }
	}
    
    function checkIfFloatAndLength(el, prop, min, max){
    	var float_reg_exp = /1\.0|0?\.[0-9]+|[01]/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);
    	
    	if (res && (res[0] == str)) {
    		if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          	}else{
            	return true;
          	}
        }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");	
        	return false;
        }
	}
	
	function checkIfFloatAndLength2(el, prop, min, max){
    	var float_reg_exp = /[0-9]*\.?[0-9]+/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);
    	
    	if (res && (res[0] == str)){
    		if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          	}else{
            	return true;
          	}
        }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");
        	
        	return false;
        }
	}

	function updateTips(txt){
		$("#tips").text(txt).addClass("ui-state-highlight");
	    setTimeout(function(){
	    	$("#tips").removeClass("ui-state-highlight", 1500);
	    }, 500);
	    
	    $("#tips").addClass("fwd-error");
	}
	
});