<?php

// main FWD Simple 3D Gallery Data class
class FWDRMGData
{
	// constants
	const DEFAULT_SKINS_NR = 2;
	
	// variables
	public $settings_ar;
    public $playlists_ar;
	
	private $_dir_url;
	
    // constructor
    public function init()
    {
		$this->_dir_url = plugin_dir_url(dirname(__FILE__));
		
		//$this->reset_presets();
		//$this->reset_playlist();
		
		$cur_data = get_option("fwdrmg_data");
   
	    if (!$cur_data)
	    {
	    	$this->init_settings();
	    	$this->set_data();
	    }
    	
    	$this->set_updates();
    	
    	$this->get_data();
    }
	
	private function reset_presets(){
		$this->get_data();
		$this->init_settings();
	    $this->set_data();
	}

	private function reset_playlist(){
		$this->get_data();
		$this->playlists_ar = array();
	    $this->set_data();
	}
	
	private function set_updates(){
		$this->get_data();
		
   		foreach ($this->settings_ar as &$preset){
			// update new or existing fields
			/*
	    	if (!array_key_exists("showSlideShowAnimation", $preset)){
	    		$preset["showSlideShowAnimation"] = "no";
			}						
			*/
    	}
		$this->set_data();
	}
    
    // Data arrays.
    private function init_settings(){
    	$this->settings_ar = array(
			array(	
				
				// Main settings.
				"id" 										=> 0,
				"name" 										=> "default",
				'displayType'								=> 'responsive',
				'autoScale'									=> true,
				'zIndex'									=> 999,
				'maxWidth'									=> 1200,
				'maxHeight'									=> 750,
				'minHeight'									=> 501,
				'startAtGallery'							=> 0,
				'startAtItem'								=> 0,
				'rightClickContextMenu' 					=> 'developer',
				'useDeepLinking' 							=> true,
				'useVectorIcons' 							=> false,
				'randomizeGalleries'						=> false,
				'showAllGalleries'							=> false,
				'buttonsAlignment' 							=> 'in',
				'mediaLazyLoading' 							=> true,
				'useDrag' 									=> true,
				'useAsModal' 								=> false,
				'showSlideShowButton' 						=> true,
				'showSlideShowAnimation' 					=> true,
				'slideShowAutoPlay' 						=> false,
				'slideShowAutoStop' 						=> true,
				'slideShowDelay' 							=> 6,
				'slideShowBkColor'							=> '#2e2e2e',
				'slideShowFillColor' 						=> '#FFFFFF',
				'useKeyboard' 								=> true,
				'useDoubleClick' 							=> true,
				'showMenuButton' 							=> true,
				'allGalleriesLabel'							=> 'All galleries',
				'menuBackgroundColor'						=> '#FFFFFF',
				'showFullscreenButton' 						=> true,
				'showZoomButton' 							=> true,
				'showCounter' 								=> true,
				'showNextAndPrevBtns' 						=> true,
				'hideButtonsOnDrag' 						=> true,
				'maxZoom' 									=> 1,
				'buttonsHideDelay' 							=> 5,
				'defaultItemWidth' 							=> 1527,
				'defaultItemHeight' 						=> 859,
				'itemOffsetHeight' 							=> 37,
				'itemOffsetHeightButtonsTop' 				=> 47,
				'spaceBetweenBtns' 							=> 8,
				'buttonsOffsetIn' 			    			=> 10,
				'buttonsOffsetOut' 							=> 10,
				'itemBorderSize' 							=> 0,
				'itemBackgroundColor' 						=> '#212121',
				'itemBorderColor' 							=> '#FFFFFF',
				'preloaderBkColor' 							=> '2e2e2e',
				'preloaderFillColor'						=> '#FFFFFF',
				'backgroundColor'							=> 'rgba(0,0,0,.99)',
				
				// Share window.
				'shareButtons' 								=> 'facebook, twitter, linkedin, tumblr, pinterest, reddit, buffer, digg, blogger',
				'shareText' 								=> 'Share on',
				'sharedURL' 								=> 'deeplink',
				'shareMainBackgroundColor' 					=> 'rgba(0,0,0,.4)',
				'shareBackgroundColor' 						=> '#FFFFFF',
				
				// Thumbnails.
				'showThumbnails' 							=> true,
				'showThumbnailsIcon' 						=> true,
				'thumbnailsHeight' 							=> 80,
				'thumbnailsOverlayColor' 					=> 'rgba(0,0,0,.4)',
				'thumbnailsBorderSize' 						=> 2,
				'thumbnailsBorderColor' 					=> '#FFFFFF',
				'spaceBetweenThumbnailsAndItem'				=> 10,
				'spaceBetweenThumbnails'					=> 5,

				// Caption.
				'caption' 									=> true,
				'captionPosition' 							=> 'bottomout',
				'showCaptionOnSmallScreens' 				=> false,
				'animateCaption' 							=> false,
				'captionAnimationType' 						=> 'motion',

				// Video & audio player.
				'useVideo' 									=> true,
				'fillEntireScreenWithPoster' 				=> true,
				'volume' 									=> 1,
				'videoAutoPlay' 							=> false,
				'nextVideoAutoPlay' 						=> false,
				'videoAutoPlayText' 						=> 'Click to unmute',
				'showLogo' 									=> false,
				'logoPath' 									=> '',
				'logoLink' 									=> '',
				'showControllerWhenVideoIsStopped' 			=> false,
				'showDefaultControllerForVimeo' 			=> true,
				'showScrubberWhenControllerIsHidden'		=> true,
				'showRewindButton'							=> true,
				'showVolumeButton'							=> true,
				'showTime'									=> true,
				'timeColor'									=> '#B9B9B9',
				'showChromecastButton'						=> true,
				'showPlaybackRateButton'					=> true,
				'showQualityButton'							=> true,
				'showFullScreenButton'						=> true,
				'showScrubberToolTipLabel'					=> true,
				'youtubeQualityButtonNormalColor'			=> '#B9B9B9',
				'youtubeQualityButtonSelectedColor'			=> '#FFFFFF',
				'scrubbersToolTipLabelBackgroundColor'		=> '#FFFFFF',
				'scrubbersToolTipLabelFontColor'			=> '#5a5a5a',
				'audioVisualizerLinesColor'					=> '#570AB8',
				'audioVisualizerCircleColor'				=> '#b9b9b9',
				'thumbnailsPreviewWidth'					=> 196,
				'thumbnailsPreviewBackgroundColor'			=> '#414141',
				'thumbnailsPreviewLabelBackgroundColor'		=> '#414141',
				'thumbnailsPreviewLabelFontColor'			=> '#CCCCCC',
				'skipToVideoText'							=> 'You can skip to video in: ',
				'skipToVideoButtonText'						=> 'Skip Ad'

			)
		);
    }

    public function get_data(){
	    $cur_data = get_option("fwdrmg_data");
	       
	    $this->settings_ar = $cur_data->settings_ar;
	    $this->playlists_ar = $cur_data->playlists_ar;
    }
    
    public function set_data(){
    	update_option("fwdrmg_data", $this);
    }
}

?>